"""XML Client Prodct

This product allows you to interface with XML-RPC server

"""

__version__='$Revision: 0.01 $'[11:-2]

from Globals import Persistent, HTMLFile, MessageDialog, HTML
import OFS.SimpleItem
from string import split, join, find, lower
import AccessControl.Role, sys, os, traceback
from Acquisition import Implicit
from OFS.SimpleItem import pretty_tb
from App.Extensions import getObject, getPath, FuncCode
from Globals import DevelopmentMode
import xmlrpclib

manage_addXMLRPCClientForm=HTMLFile('methodAdd', globals())

def manage_addXMLRPCClient(self, id, title, server, REQUEST=None):
    """Add and xmlrpcclient
    """
    i=XMLRPCClient(id,title,server)
    self._setObject(id,i)
    return self.manage_main(self,REQUEST)

class XMLRPCClient(Implicit, OFS.SimpleItem.Item, Persistent,
                  AccessControl.Role.RoleManager):

    meta_type='XMLRPC Client'
    server = ''
    
    manage_options=(
        {'label':'Properties', 'action':'manage_main'},
        {'label':'Security', 'action':'manage_access'},
        )

    __ac_permissions__=(
        ('View management screens', ('manage_main',)),
        ('Change XMLRPC Methods', ('manage_edit',)),
        ('View', ('__call__','')),
        )

    def __init__(self, id, title, server):
        self.id=id
        self.manage_edit(title, server)

    manage_main=HTMLFile('methodEdit', globals())

    def manage_edit(self, title, server, REQUEST=None):
	"""Change the XML-RPC Method

	"""

        self.title=title
	self.server=server

        if REQUEST: return MessageDialog(
            title  ='Changed %s' % self.id,
            message='%s has been updated' % self.id,
            action =REQUEST['URL1']+'/manage_main',
            target ='manage_main')

    def __call__(self, function_name, *args):
	myserv = xmlrpclib.Server(self.server)
	return apply((getattr(myserv,function_name)),args)
